---
title: Linux系统目录讲解
tags:
  - linux目录
categories:
  - linux
abbrlink: 888300cc
date: 2017-12-06 20:45:30
---

---
## /bin 目录
- 全称：Binary(Binaries)
- 作用：存放二进制可执行文件，例如命令行的cp命令。
- 备注：/bin下的命令是所有用户都可以执行的。/sbin(Spuer Binary)目录下的命令只有超级用户权限才能执行，比如分区操作。
---
## /boot 目录
- 全称 ：Boot
- 作用 ：存放操作系统的引导启动需要的文件。一般100M左右(50~200)。
- 备注 ：里面存放的vmlinuz...文件就是操作系统的内核文件，他名字就是版本号。通过bash运行 uname -r 
  可以看到系统的版本。grub引导同样在/boot下。
---
## /dev 目录
- 全称 ：Device
- 作用 ：把计算机的硬件抽象为文件存储在/dev下面。诸如硬盘(hd×),处理器(cpu),网卡(net),usb等等。
---
## /etc 目录
- 全称 ：Etcetera(其他)/Editable Text Configuration(可编辑配置文本)
- 作用 ：保存几乎所有的配置文件，系统的各个服务、组件、软件的配置文件存放地方，一般以.cnf或.conf结尾(configure)。
---
## /home 目录
- 全称 ：Home
- 作用 ：存放除root用户之外所有用户的'家目录'的目录。
  - 也就是每一个用户都会在/ｈome下有一个对应用户名的目录，用于存放该用户的私有数据。比如系统里有一个begild用户，那么/home下必有一个Beild文件夹。/home/begild下存放自己的桌面、文档等。
---
## /lib 目录
- 全称 ：Library(Libraries)
- 作用 ：linux系统运行需要的共享库文件，相当于windows的.DLl文件(动态链接库)。一般以 .so (shared object)结尾。
- 备注：同样的还有/lib32、/lib64两个文件夹，作用和/lib相同，只是运用于32位还是64位。
---
## /lost+found　目录
- 全称 ：lost+found
- 作用 ：用于存放系统发生错误的时候遗失的文件。
- 备注 ：只有root权限才能访问
---
## /mnt 目录
- 全称 ：Mount(挂载)
- 作用 ：其他文件系统挂载的挂载点。使用mount命令挂载(手动挂载)。
- 备注 ：具备同样作用的还有/media目录，不过media目录一般用于实现自动挂载。
---
## /opt　目录
- 全称 ：Optional application software packages(可选的应用程序)
- 作用 ：存放第三方、大型、版权保护的软件、游戏。
- 备注 ：安装到/opt目录下的程序，它所有的数据、库文件等等都是放在同个目录下面。
---
## /proc 目录
- 全称 ：
- 作用 ：存放进程信息，内核信息，内存使用等等快速变化的'文件'的目录。
- 备注 ：它本身不存在于实际的文件系统里。他是一种虚拟的文件系统。例如我们通过cat /proc/cpuinfo命令可以打开cpuinfo文件。里面完整的描述了cpu的信息。
---
## /root 目录
- 全称 ：Root
- 作用 ：root用户的家目录，其他的用户家目录位于/home下。
---
## /tmp 目录
- 全称 ：temp
- 作用 ：存放系统的临时文件,例如压缩文件预览.关机会自动清理,手动清理用tmpwatch命令.
---
## /usr 目录
- 全称 ：unix software resource
- 作用 ：软件安装的目录.
---
## /var 目录
- 全称 ：variable
- 作用 ：存放系统/软件运行过程中产生的缓存,登录日志等等文件.
